/////////////////////////////////////////////////////////////////////////////// 
// Copyright (C) 2003-2012, Open Design Alliance (the "Alliance"). 
// All rights reserved. 
// 
// This software and its documentation and related materials are owned by 
// the Alliance. The software may only be incorporated into application 
// programs owned by members of the Alliance, subject to a signed 
// Membership Agreement and Supplemental Software License Agreement with the
// Alliance. The structure and organization of this software are the valuable  
// trade secrets of the Alliance and its suppliers. The software is also 
// protected by copyright law and international treaty provisions. Application  
// programs incorporating this software must include the following statement 
// with their copyright notices:
//   
//   This application incorporates Teigha(R) software pursuant to a license 
//   agreement with Open Design Alliance.
//   Teigha(R) Copyright (C) 2003-2012 by Open Design Alliance. 
//   All rights reserved.
//
// By use of this software, its documentation or related materials, you 
// acknowledge and accept the above terms.
///////////////////////////////////////////////////////////////////////////////

#ifndef OdConstraintGroupNode_INCLUDED
#define OdConstraintGroupNode_INCLUDED

#include "DbConstraintsExports.h"
#include "RxObject.h"
#include "DbObjectId.h"
#include "OdArray.h"

class OdDbDwgFiler;
class OdDbDxfFiler;

#include "TD_PackPush.h"

class OdConstraintGroupNodeImpl;
class OdDbImpAssoc2dConstraintGroup;
//class OdDbAssoc2dConstraintGroupUtil;

typedef OdUInt32 OdConstraintGroupNodeId;

class DBCONSTRAINTS_EXPORT OdConstraintGroupNode : public OdRxObject
{
public:
  ODRX_DECLARE_MEMBERS(OdConstraintGroupNode);

  virtual ~OdConstraintGroupNode();

  enum GroupNodeId
  {
    kNullGroupNodeId = 0
  };

  OdConstraintGroupNodeId nodeId() const;
  OdDbObjectId owningConstraintGroupId()const;

  virtual OdResult dwgOutFields(OdDbDwgFiler* pFiler) const;
  virtual OdResult dwgInFields(OdDbDwgFiler* pFiler);

  virtual void dxfOutFields(OdDbDxfFiler* pFiler) const;
  virtual OdResult dxfInFields(OdDbDxfFiler* pFiler);


protected:
  OdConstraintGroupNode();

  OdConstraintGroupNodeImpl* m_pImpl;

  friend class OdDbImpAssoc2dConstraintGroup;
  friend class OdDbAssoc2dConstraintGroup;
//  friend class OdDbAssoc2dConstraintGroupEvalHelper;
//  friend class OdDbAssoc2dConstaintGroupCloningHelper;
};

typedef OdSmartPtr<OdConstraintGroupNode> OdConstraintGroupNodePtr;

#include "TD_PackPop.h"

#endif
